

    /* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\
    *                                                                 *
    *   mfcalc 2.0, Extended GNU Bison Example #3                     *
    *   Copyright  2005 Sebastian Pipping <webmaster@hartwork.org>   *
    *                                                                 *
    *   --> http://www.hartwork.org                                   *
    *                                                                 *
    *                                                                 *
    *   This source code is released under GPL.                       *
    *   See GPL.txt for details.                         2005-02-23   *
    *                                                                 *
    \* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */



#include <string.h>
#include "calc.h"
#include "malloc.h"


/* --------------------------------------------------- */
symrec *
putsym (char const *sym_name, int sym_type)
{
	symrec *ptr;
	ptr = (symrec *) malloc (sizeof (symrec));
	ptr->name = (char *) malloc (strlen (sym_name) + 1);
	strcpy (ptr->name,sym_name);
	ptr->type = sym_type;
	ptr->value.var = 0; /* Set value to 0 even if fctn. */
	ptr->next = (struct symrec *)sym_table;
	sym_table = ptr;
	return ptr;
}
/* --------------------------------------------------- */


/* --------------------------------------------------- */
symrec *
getsym (char const *sym_name)
{
	symrec *ptr;
	for (ptr = sym_table; ptr != (symrec *) 0;
	ptr = (symrec *)ptr->next)
	if (strcmp (ptr->name,sym_name) == 0) {
		return ptr;
	}
	return 0;
}
/* --------------------------------------------------- */


/* --------------------------------------------------- */
argrec *
live (double val)
{
	argrec * cur = (argrec *) malloc (sizeof (argrec));
	cur->val = val;
	cur->next = 0;
	return cur;
}
/* --------------------------------------------------- */


/* --------------------------------------------------- */
argrec *
grow (argrec * prev, double val)
{
	argrec * cur = (argrec *) malloc (sizeof (argrec));
	cur->val = val;
	cur->next = prev;
	return cur;
}
/* --------------------------------------------------- */


/* --------------------------------------------------- */
void
die (argrec * first)
{
	argrec * next = first;
	while (next != 0)
	{
		next = first->next;
		free (first);
		first = next;
	}
}
/* --------------------------------------------------- */
